#ifndef __TNR_CURVE_HXX
#define __TNR_CURVE_HXX

#include <stdlib.h>
#include <stdio.h>
#include "TNR_INI.hxx"


using namespace std;

class TNR_CURVE {
protected:
public:
	TNR_CURVE(){}
  ~TNR_CURVE(){}
  virtual  string getCurveType() = 0; 
  virtual  double getLength() = 0;


};

class TNR_LINE:private TNR_CURVE{
protected:
  TNR_POINT   _p[2]; 
public:
  TNR_LINE(TNR_POINT p0,TNR_POINT p1);
   string getCurveType(){return "line";}
  TNR_POINT getPosition(double u);
  double getLength();
};

class TNR_QUADRIC_CURVE:private TNR_CURVE{
protected:
  TNR_POINT   _p[3]; 
public:
  TNR_QUADRIC_CURVE(TNR_POINT p0,TNR_POINT p1,TNR_POINT p2);
   string getCurveType(){return "quadricCurve";}
  TNR_POINT getPosition(double u);
  double getLength();
};

class TNR_CUBIC_CURVE:private TNR_CURVE{
protected:
  TNR_POINT   _p[4]; 
public:
  TNR_CUBIC_CURVE(TNR_POINT p0,TNR_POINT p1,TNR_POINT p2,TNR_POINT p3);
   string getCurveType(){return "cubicCurve";}
  TNR_POINT getPosition(double u);
  double getLength();
};


class TNR_CIRCLE:private TNR_CURVE{
protected:
  double      _r; //radius
  TNR_POINT   _center;
public:
  TNR_CIRCLE(TNR_POINT center,double radius);
   string getCurveType(){return "circle";}
  TNR_POINT getPosition(double u);
  double getLength();
};

class TNR_ELLIPSE:private TNR_CURVE{
protected:
  double       _a;//major axis radius;
  double       _b;//minor axis radius;
  TNR_POINT    _center;
public:
  TNR_ELLIPSE(TNR_POINT center,double majorAxisRadius,double minorAxisRadius);
   string getCurveType(){return "ellipse";}
  TNR_POINT getPosition(double u);
  double getLength();
};

#endif
