#include "TNR_FILE_VTU.hxx"
#include <map>
#include <vector>
//#include <windows.h>




//wite vtu header of format  
void TNR_vtu_header_write(FILE* fp)
{
  fprintf(fp,"<?xml version=\"1.0\"?>\n");
  fprintf(fp,"<VTKFile type=\"UnstructuredGrid\" version=\"0.1\" byte_order=\"LittleEndian\" compressor=\"vtkZLibDataCompressor\">\n");
  fprintf(fp,"<UnstructuredGrid>\n");
}

//wite vtu footer of format  
void TNR_vtu_footer_write(FILE* fp)
{
  fprintf(fp," </UnstructuredGrid>\n");
  fprintf(fp," </VTKFile>\n");
}

//wite vtu format that paraview can view  

void  TNR_vtu_surfaceMesh_write(FILE* fp,TNR_QUAD_MESH* mesh)
{ 


  fprintf(fp,"  <Piece NumberOfPoints=\"%d\" NumberOfCells=\"%d\">\n", mesh->getNumPoints(),mesh->getNumMeshes() );
  fprintf(fp,"    <Points>\n");
  fprintf(fp,"      <DataArray type=\"Float32\" NumberOfComponents=\"3\" format=\"ascii\">\n");

  for(int i = 0; i < mesh->getNumPoints();i++){
	TNR_POINT p = mesh->getPoint(i);
    fprintf(fp,"        %f %f %f\n", p[0],p[1],p[2]);
  }

  fprintf(fp,"       </DataArray>\n");
  fprintf(fp,"    </Points>\n");
  fprintf(fp,"    <Cells>\n");
  fprintf(fp,"      <DataArray type=\"Int32\" Name=\"connectivity\" format=\"ascii\">\n");
  for(int i = 0; i < mesh->getNumMeshes();i++){
	TNR_QUAD q = mesh->getQuad(i);
    fprintf(fp,"        %d %d %d %d\n", q[0],q[1],q[2],q[3]);
  }
  fprintf(fp,"       </DataArray>\n");

  fprintf(fp,"       <DataArray type=\"Int32\" Name=\"offsets\" format=\"ascii\">\n");
  for(int i = 0; i < mesh->getNumMeshes();i++){
    fprintf(fp,"%d\n", 4*i+4);
  }

  fprintf(fp,"\n");

  fprintf(fp,"       </DataArray>\n");
  fprintf(fp,"       <DataArray type=\"UInt8\" Name=\"types\" format=\"ascii\">\n");
  for(int i = 0; i < mesh->getNumMeshes();i++){
    fprintf(fp,"%d\n", 9);
  }
  fprintf(fp,"\n");

  fprintf(fp,"       </DataArray>\n");
  fprintf(fp,"     </Cells>\n");
  fprintf(fp,"   </Piece>\n");

}



void TNR_vtu_solidMesh_write(FILE* fp,TNR_HEX_MESH* mesh)
{


  fprintf(fp,"  <Piece NumberOfPoints=\"%d\" NumberOfCells=\"%d\">\n", mesh->getNumPoints(),mesh->getNumMehes() );
  fprintf(fp,"    <Points>\n");
  fprintf(fp,"      <DataArray type=\"Float32\" NumberOfComponents=\"3\" format=\"ascii\">\n");

  for(int i = 0; i < mesh->getNumPoints();i++){
	TNR_POINT p = mesh->getPoint(i);
    fprintf(fp,"        %f %f %f\n", p[0],p[1],p[2]);
  }

  fprintf(fp,"       </DataArray>\n");
  fprintf(fp,"    </Points>\n");
  fprintf(fp,"    <Cells>\n");

  fprintf(fp,"      <DataArray type=\"Int32\" Name=\"connectivity\" format=\"ascii\">\n");
  for(int i = 0; i < mesh->getNumMehes();i++){
	TNR_HEX h = mesh->getHex(i);
    fprintf(fp,"        %d %d %d %d %d %d %d %d\n", h[0],h[1],h[2],h[3],h[4],h[5],h[6],h[7]);
  }
  fprintf(fp,"       </DataArray>\n");

  fprintf(fp,"       <DataArray type=\"Int32\" Name=\"offsets\" format=\"ascii\">\n");

  for(int i = 0; i < mesh->getNumMehes();i++){
    fprintf(fp,"%d\n", 8*i+8);
  }

  fprintf(fp,"\n");

  fprintf(fp,"       </DataArray>\n");
  fprintf(fp,"       <DataArray type=\"UInt8\" Name=\"types\" format=\"ascii\">\n");
  for(int i = 0; i < mesh->getNumMehes();i++){
    fprintf(fp,"%d\n", 12);
  }
  fprintf(fp,"\n");

  fprintf(fp,"       </DataArray>\n");
  fprintf(fp,"     </Cells>\n");
  fprintf(fp,"   </Piece>\n");



}



 
