#ifndef __TNR_HEX_MESH_HXX
#define __TNR_HEX_MESH_HXX

#include <string>
#include "TNR_VECTOR.hxx"
#include "TNR_MESH.hxx"
#include "TNR_INI.hxx"
#include "TNR_HEX_MESH.hxx"
#include <map>
#include <vector>
//#include <windows.h>


class TNR_HEX {
  int v[8];
public:
  int& operator[](int i){return v[i];}
};

class TNR_HEX_MESH:public TNR_MESH{
   vector<TNR_POINT> _points;
   vector<TNR_HEX>   _hexs;

public:
  TNR_HEX_MESH(){}
  TNR_HEX_MESH(string& name){_name = name;}
  ~TNR_HEX_MESH(){}
  string getType(){return "HEX";}
  void initilize (int vertSize,int meshSize)
  {_points.resize(vertSize);_hexs.resize(meshSize);}

  int getNumPoints(){return _points.size();}
  int getNumMehes(){return _hexs.size();}
  void  setPoint(int i,TNR_POINT p) {_points[i] = p;}
  void  setMesh(int i,TNR_HEX h) {_hexs[i] = h;}
  TNR_POINT  getPoint(int i) {return _points[i];}
  TNR_HEX   getHex(int i) {return _hexs[i];}
};


// get positon that use uv parameter
TNR_POINT  TNR_solid8_get_position(TNR_POINT* c, //control points
								   double  eta,
								   double  zeta,
								   double  xi);


// get positon that use uv parameter
TNR_POINT  TNR_solid20_get_position(TNR_POINT* c, //control points
								   double  pu,
								   double  pv,
								   double  pt);



void TNR_hex_create_mesh(TNR_SECTION* body,
							 TNR_COMAMND* commands,
							 TNR_HEX_MESH* mesh);


#endif