#include "TNR_INI.hxx"
#include "TNR_COMMON.hxx"
#include <stdlib.h>
#include <stdio.h>
//#include <windows.h>
#include <string>
#include <string.h>
#include <assert.h>

//#pragma warning(disable:4129)

string trimSpace(const string& s)
{
  std::string::const_iterator left = s.begin();
  std::string::const_iterator right = s.end();
  // [󔒕 
  while(isspace(*left)) {
    ++left; 
  }

  if(left != right) {
  // E[󔒕 

    do {
      --right; 
    } while(isspace(*right));
    ++right; // E[̔󔒕Ă̂ňꕶ߂ } 
  }
  // [ƉE[̊Ԃ̕Ԃ 
  return std::string(left, right); 
} 

string trimDobleQuotes(const string& s)
{
  if(s.size() > 2 && s[0] == '"'  && s[s.size()-1] == '"'){
     return s.substr(1, s.size()-2); 
  }

  return s;
} 



//===================================
//RXgN^
//===================================
TNR_INI::TNR_INI()
{
	_thisSection = NULL;
}

//===================================
//fXgN^
//===================================
TNR_INI::~TNR_INI()
{

}


//==========================================
//w肵t@CJ܂B
//==========================================
bool TNR_INI::load(const char* iniFileName)
{
	printf("file name = %s\n",iniFileName);

	FILE *fp = fopen(iniFileName,"r");
	if(fp == NULL)
	{
		return false;
	}
	char pcBuffer[BUFFER_SIZE];
	bool hr;
	bool dataProcess = false;

	while(fgets(pcBuffer,BUFFER_SIZE-1,fp) != NULL){

       string buffer = pcBuffer;
       printf("data = %s\n",pcBuffer);

		//
		if(buffer.size() == 0){
			continue;
		}
		//s݂
		int newLine = buffer.find("\n",0);
        pcBuffer[newLine] ='\0';
		buffer = pcBuffer;
		

		//f[^}[N
		if(buffer == "<data>"){
          dataProcess = true;
          continue;
		}

		//f[^̓ǂݍݏ
		if(dataProcess == true){
			if(!strcmp(pcBuffer,"</data>")){
               dataProcess = false;
			}else{
                _thisSection->addData(pcBuffer);
			}
		}else{
		  //͂
	      AnalysisOneString(buffer);
		}
	}

    fclose(fp);
	return true;
}

bool TNR_INI::save(const char* iniFileName)
{

	FILE *fp = fopen(iniFileName,"w");
	if(fp == NULL)
	{
		return false;
	}

	
	for(int i = 0; i < this->getNumSection();i++){
       TNR_SECTION* section = this->getSection(i);
	   fprintf(fp,"[%s]\n",section->getName().c_str());
	   //key̏o
	   for(int j = 0; j < section->getNumKey();j++){
		   TNR_KEY* key = section->getKey(j);
		   string key1 = key->getKey();
           string val = key->getStringValue();
		   fprintf(fp,"%s = %s\n",key->getKey().c_str(),key->getStringValue().c_str());
	   }

	   //datȁo
	   fprintf(fp,"<data>\n");
	   for(int j = 0; j <  section->getNumData();j++){
		 fprintf(fp,"%s\n",section->getData(j).c_str());
	   }
	   fprintf(fp,"</data>\n");
	   fprintf(fp,"\n");
	}


  fclose(fp);

  return 0;

}

bool TNR_INI::AnalysisOneString(string& buff)
{
	//ZNVf[^̓ǂݎ
    char theSection[BUFFER_SIZE];
	if(sscanf(buff.c_str(),"[%[^\\]]",theSection) == 1)
	{
		string section = theSection;
		AddSection(section);
		return true;
	}
	
	///////////////////////
	//read key value
	//////////////////////
	//if "=" dont found,this line skiped
	int eqPos = buff.find("=",0);
	if((eqPos == string::npos) || eqPos==0){
		return true;
    }

	//if section dont found,go to err
	if(_thisSection == NULL){
       TNR_ERR_write_message("Section not fond\n");
	   return false;
	}
	//split "=" and trim space
    string key;
	key.append(buff,0,eqPos);
	string value;
    value.append(buff,eqPos+1,buff.size()-1);
	key = trimSpace(key);
    value= trimSpace(value);
    this->AddData(key,value);

	return true;
}



//===================================
//Ps͂܂B
//===================================


bool TNR_INI::AddSection(string& sectionName)
{

	TNR_SECTION* theSection = new TNR_SECTION(sectionName,this);
	_sections.push_back(theSection);
	_thisSection = theSection;

	return true;
}

bool TNR_INI::AddData(string& key,string& value)
{

	//f[^ǉ
    TNR_KEY* keyValue = new TNR_KEY(key,value);
	_thisSection->addKeyValue(keyValue);

	return true;
}


void  TNR_INI::deleteSectionByKey(string searchKey,string searchValue)
{
   for (vector<TNR_SECTION*>::iterator itr=_sections.begin();itr!=_sections.end();){
     TNR_SECTION* a = *(itr);
	 if(a->getStringValue(searchKey,"") == searchValue){
          itr=_sections.erase(itr);
	 }else{
          ++itr;
	 }
  }


}
void  TNR_INI::getSection(const string& sectionName,vector<TNR_SECTION*>& return_Section)
{
  for(int i = 0; i < _sections.size();i++){
	if(_sections[i]->getName() == sectionName){
 	 return_Section.push_back(_sections[i]);
	}
  }
}

bool  TNR_INI::getSection(const string& searchSectionName,const string searchKey,string searchValue,vector<TNR_SECTION*>& returnSections)
{
  for(int i = 0; i < _sections.size();i++){
	if(_sections[i]->getName() == searchSectionName){
		if( _sections[i]->getStringValue(searchKey,"") == searchValue){
			returnSections.push_back(_sections[i]);
		}
	}
  }

  return true;

}

bool  TNR_INI::getSection(const string searchKey,
						  string searchValue,
						  vector<TNR_SECTION*>& returnSections)
{
  for(int i = 0; i < _sections.size();i++){
	if( _sections[i]->getStringValue(searchKey,"") == searchValue){
	  returnSections.push_back(_sections[i]);
	}
  }

  return true;
}

void  TNR_SECTION::copy(TNR_SECTION& s)
{
 
  s.setName(_name);

  for(int i = 0; i < _keys.size();i++){
    TNR_KEY* k = new TNR_KEY;
	k->setKey(_keys[i]->getKey());
	k->setValue(_keys[i]->getStringValue());
	s.addKeyValue(k);
  }

  for(int i = 0; i < _rowData.size();i++){
    
    s.addData(_rowData[i]);
  }

  s.setOwner(_owner);

}

string TNR_COMAMND::getStringValue(const string& key,string default)
{
  for(int i = 0; i < _keys.size();i++){
    if(_keys[i] == key)
      return _values[i];
  }

  return default;
}

int TNR_COMAMND::getIntValue(const string& key,int default){
  for(int i = 0; i < _keys.size();i++){
    if(_keys[i] == key)
		return atoi(_values[i].c_str());
  }
  return default;
}

double TNR_COMAMND::getDoubleValue(const string& key,double default){
  for(int i = 0; i < _keys.size();i++){
    if(_keys[i] == key)
		return atof(_values[i].c_str());
  }
  return default;
}

void  TNR_COMAMND::setCommandLine(string& line) {

    char seps[]   = ",";
    char *token;

    char str[1024];
    strcpy(str,line.c_str());

    token = strtok( str, seps ); 

    int count = 0;

   while( token != NULL )
   {
      // While there are tokens in "string"
	  string keyValue = token;
	  if(count == 0){
         _commandName=trimDobleQuotes(trimSpace(keyValue));
	  }else{
	    int eqPos = keyValue.find('=');
	    if(string::npos != eqPos){
	      string key = keyValue.substr(0,eqPos);
	      string keyFix  = trimDobleQuotes(trimSpace(key));

	      string value= keyValue.substr(eqPos+1,keyValue.size()-1);
	      string valueFix = trimDobleQuotes(trimSpace(value));
		  _keys.push_back(keyFix);
		  _values.push_back(valueFix);

		}else{
		  fprintf(stderr,"Err Argument: Command = %s(Err of argument:%s)\n ",_commandName.c_str(),keyValue.c_str());
	    }
	  }

      count++;

      // Get next token: 
      token = strtok( NULL, seps ); //
   }
 }

void TNR_COMAMND::print(FILE*fp) 
{ 
   fprintf(fp,"Commandname = %s\n", _commandName.c_str());
   for(int i = 0; i < _keys.size();i++){
     fprintf(fp,"%d: %s = %s\n",i,_keys[i].c_str(),_values[i].c_str());
   }   
}




#if 0

string* TNR_INI::GetString(const char *inSection,const char *inKey)
{


	map<string,Section *>::iterator p = _sections.find(string(inSection));
	if(p == _sections.end())
	{
		_error = false;
		return NULL;
	}

	Section *theSection = p->second;
	map<string,string>::iterator q = theSection->find(string(inKey));
	if(q == theSection->end())
	{
		_error = false;
		return NULL;
	}

	return &(q->second);
}






//===============================
//񂩂畂_擾
//===============================
double TNR_INI::GetDouble(char *inSection,char *inKey)
{
	string *theString = GetString(inSection,inKey);
	if(theString == NULL)
	{
		_error = false;
		return 0.0f;
	}

	const char *src = theString->c_str();
	bool dTNRFlag = 0;
	for(int i = 0; src[i] != '\0';i++)
	{
		if(src[i] == '.')
		{
			if(dTNRFlag == 1)
			{
				_error = false;
				return 0.0f;
			}

			if(!isdigit(src[i + 1]))
			{
				_error = false;
				return 0.0f;
			}
			dTNRFlag = 1;
		}
		else if(!isdigit(src[i]))
		{
			_error = false;
			return 0.0f;
		}
	}
	
	if(dTNRFlag == 0)
	{
		_error = false;
		return 0.0f;
	}

	return atof(src);
}




//===============================
//񂩂琮擾
//===============================
int TNR_INI::GetInt(char *inSection,char *inKey)
{
	string *theString = GetString(inSection,inKey);
	if(theString == NULL)
	{
		_error= false;
		return 0;
	}

	const char *src = theString->c_str();
	for(int i = 0; src[i] != '\0';i++)
	{
		if(!isdigit(src[i]))
		{
			_error = false;
			return 0;
		}
	}

	return atoi(src);
}




//ZNVAL[l̎擾
int GetPrivateProfileString_x(TNR_INI* iniPtr,
							  const string&  lpAppName, // ZNV
                              const string&  lpKeyName, // L[
                              const string&  lpDefault, // Ȃꍇ̃ftHg̕
                              string& lpReturnedString, // 񂪊i[obt@
                              int nSize)                // obt@̃TCY
{
  lpReturnedString = "";

  if(iniPtr == NULL)
	  return -1;

  string*  result;
  result = iniPtr->GetString(lpAppName.c_str(),lpKeyName.c_str());

  if(result== NULL){
    lpReturnedString = lpDefault;

	return -1;
  }
  



  //w肵𒴂Ăꍇ
  if(result->size() > nSize){
	char buf[1024];
    strncpy(buf,result->c_str(),nSize);
    lpReturnedString = buf;
  }else{  //w肵𒴂ĂȂꍇ
    lpReturnedString = result->c_str();
  }

  return 0; 

}

int  WritePrivateProfileString_x(TNR_INI* iniPtr,
                                 const string& lpAppName,  // ZNV
                                 const string& lpKeyName,  // L[
                                 const string& lpString)   // ǉׂ
{

	//ZNV̏
	Section* theSection = NULL;
    map<string,Section *>::iterator p = iniPtr->_sections.find(lpAppName);
	if(p == iniPtr->_sections.end()){
	  //ZNVꍇ
	  theSection = new Section;
      iniPtr->_sections.insert(pair<string,Section *>(string(lpAppName),theSection));
	}else{
	  theSection = p->second;
	}

	(*theSection)[lpKeyName] = lpString;
     return 0;
}

int TNR_iniFile_get_num_section(TNR_INI* iniPtr)
{
  return iniPtr->_sections.size();
}


int TNR_iniFile_get_nth_sectionName(TNR_INI* iniPtr,unsigned int sectionIndex,string& returnedSectionName)
{
   if(iniPtr->_sections.size() -1  <  sectionIndex){
      return -1;
   }

   int count = 0;
   for (map<string,Section*>::iterator i = iniPtr->_sections.begin(); i != iniPtr->_sections.end();i++){
     if(count == sectionIndex){
       returnedSectionName = i->first;
       return 0;
	 }
	 count++;
   }
   return -1;
}

//ZNVt@CKey擾
int TNR_section_get_num_key(TNR_INI* iniPtr, const string& sectionName)
{

	map<string,Section *>::iterator p = iniPtr->_sections.find(sectionName);
	if(p == iniPtr->_sections.end())
	{
	  return -1;
	}

    Section* section =    p->second;

 	//Keỹ[v
	int count = 0;
	for (map<string,string>::iterator q = section->begin(); q != section->end();q++){
		count++;
 
    }
  

   return count;
}


//Key擾
//Key擾
//ZNV݂Ȃ烊^[R[h0ȉ̐Ԃ
int TNR_section_get_nth_keyName(TNR_INI* iniPtr, //IniIuWFNg|C^
								string& sectionName, //ZNV
                                unsigned int keyIndex, //KeyCfbNX
		                        string& returnedkeyName) //ꂽKey

{
	assert(keyIndex >= 0);
	map<string,Section *>::iterator p = iniPtr->_sections.find(sectionName);
	if(p == iniPtr->_sections.end())
	{
	  return -1;
	}

    Section* section =    p->second;

 	//Keỹ[v
	int count = 0;
	for (map<string,string>::iterator q = section->begin(); q != section->end();q++){
		if(keyIndex == count){
         returnedkeyName   =  q->first;
		}
    }
  

   return 0;

}

int TNR_section_delete(TNR_INI* iniPtr, //IniIuWFNg|C^
                       const string& sectionName) //ZNV
{
  
  map<string,Section *>::iterator p = iniPtr->_sections.find(sectionName);
  if(p == iniPtr->_sections.end()){
	  return -1;
  }


  Section* section = p->second;

  delete section;

  iniPtr->_sections.erase(sectionName);

  return 0;
}

//Key̍폜
int TNR_section_delete_key(TNR_INI* iniPtr, //IniIuWFNg|C^
                           const string& sectionName,//ZNV
						   const string& keyName)  //key
{

  map<string,Section *>::iterator p = iniPtr->_sections.find(sectionName);
  if(p == iniPtr->_sections.end()){
	  return -1;
  }

  Section* section = p->second;
  (*section).erase(keyName);

  return 0;
}
#endif